// Generator created by Nikolay Budin

#ifdef DEBUG
#  define _GLIBCXX_DEBUG
#endif
#include <bits/stdc++.h>
#include <ext/pb_ds/assoc_container.hpp>
#include "testlib.h"
#define ff first
#define ss second
#define szof(x) ((int)x.size())
#ifndef LOCAL
#  define cerr __get_ce
#endif

using namespace std;
typedef long long ll;
typedef long double ld;
typedef pair<int, int> pii;
typedef unsigned long long ull;

using namespace __gnu_pbds;
template <typename T> using ordered_set = tree<T, null_type, less<T>, rb_tree_tag, tree_order_statistics_node_update>;
template <typename K, typename V> using ordered_map = tree<K, V, less<K>, rb_tree_tag, tree_order_statistics_node_update>;

int const INF = (int)1e9 + 1e3;
ll const INFL = (ll)1e18 + 1e6;

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};
string dir_symb = "^>v<";

int get_dir(char c) {
	for (int i = 0; i < 4; ++i) {
		if (c == dir_symb[i]) {
			return i;
		}
	}
	return -1;
}

int main(int argc, char* argv[]) {
	registerGen(argc, argv, 1);

	int n = atoi(argv[1]);
	int k = atoi(argv[2]);
	string part_type = argv[3];
	string type = argv[4];

	vector<vector<char>> outp(n, vector<char>(n, '.'));

	vector<int> rows(n), columns(n);
	iota(rows.begin(), rows.end(), 0);
	iota(columns.begin(), columns.end(), 0);
	if (type == "sorted") {

	} else if (type == "swaps") {
		for (int i = 0; i < 10; ++i) {
			swap(rows[rnd.next(0, n - 1)], rows[rnd.next(0, n - 1)]);
			swap(columns[rnd.next(0, n - 1)], columns[rnd.next(0, n - 1)]);
		}
	} else {
		shuffle(rows.begin(), rows.end());
		shuffle(columns.begin(), columns.end());
	}
	rows.resize(k);
	columns.resize(k);

	for (int i = 0; i < k; ++i) {
		outp[rows[i]][columns[i]] = 'O';
	}

	ordered_set<pii> cells;

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (outp[i][j] == 'O') {
				for (int d = 0; d < 4; ++d) {
					int nx = i + dx[d];
					int ny = j + dy[d];
					if (0 <= nx && nx < n && 0 <= ny && ny < n && outp[nx][ny] != 'O') {
						cells.insert({nx, ny});
					}
				}
			}
		}
	}

	while (szof(cells)) {
		auto it = cells.find_by_order(rnd.next(0, szof(cells) - 1));
		auto [x, y] = *it;
		cells.erase(it);

		vector<int> pos_dirs;
		for (int d = 0; d < 4; ++d) {
			int nx = x + dx[d];
			int ny = y + dy[d];
			if (0 <= nx && nx < n && 0 <= ny && ny < n && (outp[nx][ny] == 'O' || get_dir(outp[nx][ny]) == d)) {
				pos_dirs.push_back(d);
			}
		}

		assert(szof(pos_dirs));
		int dir = pos_dirs[rnd.next(0, szof(pos_dirs) - 1)];
		outp[x][y] = dir_symb[dir];
		int nx = x + dx[(dir + 2) % 4];
		int ny = y + dy[(dir + 2) % 4];
		if (0 <= nx && nx < n && 0 <= ny && ny < n && outp[nx][ny] == '.') {
			cells.insert({nx, ny});
		}
	}

	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (outp[i][j] == 'O') {
				for (int d = 0; d < 4; ++d) {
					int len = 0;
					int x = i + dx[d];
					int y = j + dy[d];
					while (0 <= x && x < n && 0 <= y && y < n && get_dir(outp[x][y]) == (d + 2) % 4) {
						x += dx[d];
						y += dy[d];
						++len;
					}

					int left_len = len;
					if (part_type == "empty") {
						left_len = 0;
					} else if (part_type == "half") {
						left_len = len / 2;
					} else if (part_type == "random") {
						left_len = rnd.wnext(len + 1, 2);
					} else if (part_type == "cut_end") {
						if (left_len && rnd.next(0, 10) == 0) {
							--left_len;
						}
					} else if (part_type == "cut_free_ends") {
						if (0 <= x && x < n && 0 <= y && y < n && outp[x][y] != '.') {

						} else {
							while (left_len) {
								x -= dx[d];
								y -= dy[d];
								bool ok = true;
								for (int qq : {-1, 1}) {
									int dd = (d + qq + 4) % 4;
									int nx = x + dx[dd];
									int ny = y + dy[dd];

									if (0 <= nx && nx < n && 0 <= ny && ny < n && (outp[nx][ny] == 'O' || get_dir(outp[nx][ny]) == dd)) {
										ok = false;
										break;
									}
								}

								if (!ok) {
									break;
								}
								--left_len;
							}
						}
					}

					x = i + dx[d];
					y = j + dy[d];
					for (int q = 0; q < len; ++q) {
						if (q >= left_len) {
							outp[x][y] = '.';
						}
						x += dx[d];
						y += dy[d];
					}
				}
			}
		}
	}

	if (type == "split") {
		while (true) {
			int x = rnd.next(0, n - 1);
			int y = rnd.next(0, n - 1);
			int dir = get_dir(outp[x][y]);
			if (dir == -1) {
				continue;
			}
			int nx = x + dx[dir];
			int ny = y + dy[dir];
			int px = x - dx[dir];
			int py = y - dy[dir];
			if (0 <= nx && nx < n && 0 <= ny && ny < n && 0 <= px && px < n && 0 <= py && py < n && outp[nx][ny] == outp[x][y] && outp[px][py] == outp[x][y]) {
				outp[x][y] = '.';
				break;
			}
		}
	}

	if (type == "continue") {
		while (true) {
			int x = rnd.next(0, n - 1);
			int y = rnd.next(0, n - 1);
			int dir = get_dir(outp[x][y]);
			if (dir == -1) {
				continue;
			}
			int nx = x - dx[dir];
			int ny = y - dy[dir];
			if (0 <= nx && nx < n && 0 <= ny && ny < n) {
				int dir2 = get_dir(outp[nx][ny]);
				if (dir2 != -1 && dir2 != dir) {
					int nx2 = nx - dx[dir];
					int ny2 = ny - dy[dir];
					if (0 <= nx2 && nx2 < n && 0 <= ny2 && ny2 < n && outp[nx2][ny2] == '.') {
						outp[nx2][ny2] = outp[x][y];
						break;
					}
				}
			}
		}
	}


	cout << n << "\n";
	for (int i = 0; i < n; ++i) {
		for (int j = 0; j < n; ++j) {
			if (get_dir(outp[i][j]) != -1) {
				outp[i][j] = '+';
			}
			cout << outp[i][j];
		}
		cout << "\n";
	}

	return 0;
}